3 # Copyright (c) 2005 Junio C Hamano
6 test_description='the test framework itself.'
8 ################################################################
9 # It appears that people try to run tests without building...
11 if ! test -x ../notmuch
13 echo >&2 'You do not seem to have built notmuch yet.'
19 ################################################################
21 test_expect_success 'success is reported like this' '
24 test_set_prereq HAVEIT
26 test_expect_success HAVEIT 'test runs if prerequisite is satisfied' '
27 test_have_prereq HAVEIT &&
32 test_expect_success 'tests clean up after themselves' '
33 test_when_finished clean=yes
37 test_expect_code 1 'tests clean up even after a failure' '
38 test_when_finished cleaner=yes &&
42 if test $clean$cleaner != yesyes
44 say "bug in test framework: cleanup commands do not work reliably"
48 test_expect_code 2 'failure to clean up causes the test to fail' '
49 test_when_finished "(exit 2)"
52 # Ensure that all tests are being run
53 test_begin_subtest 'Ensure that all available tests will be run by notmuch-test'
54 eval $(sed -n -e '/^TESTS="$/,/^"$/p' $TEST_DIRECTORY/notmuch-test)
55 tests_in_suite=$(for i in $TESTS; do echo $i; done | sort)
56 available=$(find "$TEST_DIRECTORY" -maxdepth 1 -type f \
57 '(' -perm -100 -o -perm -10 -o -perm -1 ')' \
58 ! -name aggregate-results.sh \
61 ! -name notmuch-test \
63 ! -name random-corpus \
66 ! -name test-verbose \
67 | sed 's,.*/,,' | sort)
68 test_expect_equal "$tests_in_suite" "$available"
70 EXPECTED=$TEST_DIRECTORY/test.expected-output
71 suppress_diff_date() {
72 sed -e 's/\(.*\-\-\- test-verbose\.4\.\expected\).*/\1/' \
73 -e 's/\(.*\+\+\+ test-verbose\.4\.\output\).*/\1/'
76 test_begin_subtest "Ensure that test output is suppressed unless the test fails"
77 output=$(cd $TEST_DIRECTORY; ./test-verbose 2>&1 | suppress_diff_date)
78 expected=$(cat $EXPECTED/test-verbose-no | suppress_diff_date)
79 test_expect_equal "$output" "$expected"
81 test_begin_subtest "Ensure that -v does not suppress test output"
82 output=$(cd $TEST_DIRECTORY; ./test-verbose -v 2>&1 | suppress_diff_date)
83 expected=$(cat $EXPECTED/test-verbose-yes | suppress_diff_date)
84 # Do not include the results of test-verbose in totals
85 rm $TEST_DIRECTORY/test-results/test-verbose
86 rm -r $TEST_DIRECTORY/tmp.test-verbose
87 test_expect_equal "$output" "$expected"
90 ################################################################
91 # Test mail store prepared in test-lib.sh
94 'test that mail store was created' \
95 'test -d "${MAIL_DIR}"'
98 find "${MAIL_DIR}" -type f -print >should-be-empty
100 'mail store should be empty' \
101 'cmp -s /dev/null should-be-empty'
103 test_expect_success \
104 'NOTMUCH_CONFIG is set and points to an existing file' \
105 'test -f "${NOTMUCH_CONFIG}"'
107 test_expect_success \
108 'PATH is set to this repository' \
109 'test "`echo $PATH|cut -f1 -d: | sed -e 's,/test/valgrind/bin$,,'`" = "`dirname ${TEST_DIRECTORY}`"'